import { DEFALUT_TOKENS } from "../config/chain_config";

export interface IToken {
  address: string;
  type: "eth" | "erc20";
  default: boolean;
  symbol?: string;
  balance?: string;
  decimal: number;
  image?: string;
  last?: number;
}

export interface INFT {
  address: string;
  type: "erc721" | "erc1155";
  index: number;
  tokenId?: string;
  image?: string;
  name?: string;
  desc?: string;
  last?: number;
}

export function initNFT(address: string, index: number, type: 'erc721'|'erc1155') {
  return {
    address,
    index,
    type
  };
}

export interface ITokenData {
  tokens: IToken[];
  heros: INFT[];
  weapons: INFT[];
  chips: INFT[];
}
export interface IAccount {
  address: string;
  type: number;
  index: number;
  nickname?: string;
  avatar?: string;
  tokenData: {
    [key: number]: ITokenData;
  };
}

export function initAccount({
  address,
  chain,
  nickname,
  type,
  index
}: {
  address: string;
  chain: number;
  nickname: string;
  type: number,
  index: number
}): IAccount {
  let chainData = {};
  let data: IAccount = {
    address,
    nickname,
    type,
    index,
    tokenData: chainData,
  };
  let tokens = DEFALUT_TOKENS[chain];
  chainData[chain] = {
    tokens,
    heros: [],
    weapons: [],
    chips: [],
  };
  return data;
}
