import { records } from "../api/RecordApi";
import { singleton } from "../decorator/singleton.decorator";

@singleton
export class TranHistorySvr {
  /**
   * eth history
   */
  public async ethRecords(start: number, limit: number) {
    start = start | 0;
    limit = limit | 0;
    const data = { start, limit, chain: jc.wallet.currentChain.id };
    return records(data);
  }

  /**
   * token history
   */
  public async tokenRecords({
    address,
    tokenId,
    start,
    limit,
  }: {
    address: string;
    tokenId?: string;
    start: number;
    limit: number;
  }) {
    start = start | 0;
    limit = limit | 0;
    const data: any = {
      start,
      limit,
      chain: jc.wallet.currentChain.id,
      "details.address": address,
    };
    if (tokenId) {
      data["details.id"] = tokenId + "";
    }
    return records(data);
  }
}
